searchNodes=[{"doc":"A HTTP toolkit for building API clients using middlewares. Building API client use Tesla macro will generate basic HTTP functions (e.g. get/3 , post/4 , etc.) inside your module. It supports following options: :only - builder will generate only functions included in the given list :except - builder will not generate the functions that are listed in the options :docs - when set to false builder will not add documentation to generated functions Examples defmodule ExampleApi do use Tesla , only : [ :get ] , docs : false plug Tesla.Middleware.BaseUrl , &quot;http://api.example.com&quot; plug Tesla.Middleware.JSON def fetch_data do get ( &quot;/data&quot; ) end end In example above ExampleApi.fetch_data/0 is equivalent of ExampleApi.get(&quot;/data&quot;) . defmodule ExampleApi do use Tesla , except : [ :post , :delete ] plug Tesla.Middleware.BaseUrl , &quot;http://api.example.com&quot; plug Tesla.Middleware.JSON def fetch_data do get ( &quot;/data&quot; ) end end In example above except: [:post, :delete] will make sure that post functions will not be generated for this module. Direct usage It is also possible to do request directly with Tesla module. Tesla . get ( &quot;https://example.com&quot; ) Common pitfalls Direct usage won't include any middlewares. In following example: defmodule ExampleApi do use Tesla , only : [ :get ] , docs : false plug Tesla.Middleware.BaseUrl , &quot;http://api.example.com&quot; plug Tesla.Middleware.JSON def fetch_data do Tesla . get ( &quot;/data&quot; ) end end call to ExampleApi.fetch_data/0 will fail, because request will be missing base URL. Default adapter By default Tesla is using Tesla.Adapter.Httpc , because :httpc is included in Erlang/OTP and does not require installation of any additional dependency. It can be changed globally with config: config :tesla , :adapter , Tesla.Adapter.Hackney or by Tesla.Builder.adapter/2 macro for given API client module: defmodule ExampleApi do use Tesla adapter Tesla.Adapter.Hackney ... end","ref":"Tesla.html","title":"Tesla","type":"module"},{"doc":"","ref":"Tesla.html#build_adapter/1","title":"Tesla.build_adapter/1","type":"function"},{"doc":"","ref":"Tesla.html#build_client/2","title":"Tesla.build_client/2","type":"function"},{"doc":"Builds URL with the given query params. Useful when you need to create an URL with dynamic query params from a Keyword list Examples iex&gt; Tesla . build_url ( &quot;http://api.example.com&quot; , [ user : 3 , page : 2 ] ) &quot;http://api.example.com?user=3&amp;page=2&quot; # URL that already contains query params iex&gt; url = &quot;http://api.example.com?user=3&quot; iex&gt; Tesla . build_url ( url , [ page : 2 , status : true ] ) &quot;http://api.example.com?user=3&amp;page=2&amp;status=true&quot;","ref":"Tesla.html#build_url/2","title":"Tesla.build_url/2","type":"function"},{"doc":"Dynamically build client from list of middlewares and/or adapter. # add dynamic middleware client = Tesla . client ( [ { Tesla.Middleware.Headers , [ { &quot;authorization&quot; , token } ] } ] ) Tesla . get ( client , &quot;/path&quot; ) # configure adapter in runtime client = Tesla . client ( [ ] , Tesla.Adapter.Hackney ) client = Tesla . client ( [ ] , { Tesla.Adapter.Hackney , pool : :my_pool } ) Tesla . get ( client , &quot;/path&quot; ) # complete module example defmodule MyApi do # note there is no need for `use Tesla` @middleware [ { Tesla.Middleware.BaseUrl , &quot;https://example.com&quot; } , Tesla.Middleware.JSON , Tesla.Middleware.Logger ] @adapter Tesla.Adapter.Hackney def new ( opts ) do # do any middleware manipulation you need middleware = [ { Tesla.Middleware.BasicAuth , username : opts [ :username ] , password : opts [ :password ] } ] ++ @middleware # allow configuring adapter in runtime adapter = opts [ :adapter ] || @adapter # use Tesla.client/2 to put it all together Tesla . client ( middleware , adapter ) end def get_something ( client , id ) do # pass client directly to Tesla.get/2 Tesla . get ( client , &quot;/something/ \#{ id } &quot; ) # ... end end client = MyApi . new ( username : &quot;admin&quot; , password : &quot;secret&quot; ) MyApi . get_something ( client , 42 )","ref":"Tesla.html#client/2","title":"Tesla.client/2","type":"function"},{"doc":"Perform a DELETE request. See request/1 or request/2 for options definition. delete ( &quot;/users&quot; ) delete ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) delete ( client , &quot;/users&quot; ) delete ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) delete ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Tesla.html#delete/3","title":"Tesla.delete/3","type":"function"},{"doc":"Perform a DELETE request. See request!/1 or request!/2 for options definition. delete! ( &quot;/users&quot; ) delete! ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) delete! ( client , &quot;/users&quot; ) delete! ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) delete! ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Tesla.html#delete!/3","title":"Tesla.delete!/3","type":"function"},{"doc":"","ref":"Tesla.html#delete_header/2","title":"Tesla.delete_header/2","type":"function"},{"doc":"","ref":"Tesla.html#encode_query/1","title":"Tesla.encode_query/1","type":"function"},{"doc":"Perform a GET request. See request/1 or request/2 for options definition. get ( &quot;/users&quot; ) get ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) get ( client , &quot;/users&quot; ) get ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) get ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Tesla.html#get/3","title":"Tesla.get/3","type":"function"},{"doc":"Perform a GET request. See request!/1 or request!/2 for options definition. get! ( &quot;/users&quot; ) get! ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) get! ( client , &quot;/users&quot; ) get! ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) get! ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Tesla.html#get!/3","title":"Tesla.get!/3","type":"function"},{"doc":"Returns value of header specified by key from :headers field in Tesla.Env . Examples # non existing header iex&gt; env = % Tesla.Env { headers : [ { &quot;server&quot; , &quot;Cowboy&quot; } ] } iex&gt; Tesla . get_header ( env , &quot;some-key&quot; ) nil # existing header iex&gt; env = % Tesla.Env { headers : [ { &quot;server&quot; , &quot;Cowboy&quot; } ] } iex&gt; Tesla . get_header ( env , &quot;server&quot; ) &quot;Cowboy&quot; # first of multiple headers with the same name iex&gt; env = % Tesla.Env { headers : [ { &quot;cookie&quot; , &quot;chocolate&quot; } , { &quot;cookie&quot; , &quot;biscuits&quot; } ] } iex&gt; Tesla . get_header ( env , &quot;cookie&quot; ) &quot;chocolate&quot;","ref":"Tesla.html#get_header/2","title":"Tesla.get_header/2","type":"function"},{"doc":"","ref":"Tesla.html#get_headers/2","title":"Tesla.get_headers/2","type":"function"},{"doc":"Perform a HEAD request. See request/1 or request/2 for options definition. head ( &quot;/users&quot; ) head ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) head ( client , &quot;/users&quot; ) head ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) head ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Tesla.html#head/3","title":"Tesla.head/3","type":"function"},{"doc":"Perform a HEAD request. See request!/1 or request!/2 for options definition. head! ( &quot;/users&quot; ) head! ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) head! ( client , &quot;/users&quot; ) head! ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) head! ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Tesla.html#head!/3","title":"Tesla.head!/3","type":"function"},{"doc":"Perform a OPTIONS request. See request/1 or request/2 for options definition. options ( &quot;/users&quot; ) options ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) options ( client , &quot;/users&quot; ) options ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) options ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Tesla.html#options/3","title":"Tesla.options/3","type":"function"},{"doc":"Perform a OPTIONS request. See request!/1 or request!/2 for options definition. options! ( &quot;/users&quot; ) options! ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) options! ( client , &quot;/users&quot; ) options! ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) options! ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Tesla.html#options!/3","title":"Tesla.options!/3","type":"function"},{"doc":"Perform a PATCH request. See request/1 or request/2 for options definition. patch ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) patch ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) patch ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) patch ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"Tesla.html#patch/4","title":"Tesla.patch/4","type":"function"},{"doc":"Perform a PATCH request. See request!/1 or request!/2 for options definition. patch! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) patch! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) patch! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) patch! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"Tesla.html#patch!/4","title":"Tesla.patch!/4","type":"function"},{"doc":"Perform a POST request. See request/1 or request/2 for options definition. post ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) post ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) post ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) post ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"Tesla.html#post/4","title":"Tesla.post/4","type":"function"},{"doc":"Perform a POST request. See request!/1 or request!/2 for options definition. post! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) post! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) post! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) post! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"Tesla.html#post!/4","title":"Tesla.post!/4","type":"function"},{"doc":"Perform a PUT request. See request/1 or request/2 for options definition. put ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) put ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) put ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) put ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"Tesla.html#put/4","title":"Tesla.put/4","type":"function"},{"doc":"Perform a PUT request. See request!/1 or request!/2 for options definition. put! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) put! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) put! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) put! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"Tesla.html#put!/4","title":"Tesla.put!/4","type":"function"},{"doc":"","ref":"Tesla.html#put_body/2","title":"Tesla.put_body/2","type":"function"},{"doc":"","ref":"Tesla.html#put_header/3","title":"Tesla.put_header/3","type":"function"},{"doc":"","ref":"Tesla.html#put_headers/2","title":"Tesla.put_headers/2","type":"function"},{"doc":"Adds given key/value pair to :opts field in Tesla.Env . Useful when there's need to store additional middleware data in Tesla.Env Examples iex&gt; % Tesla.Env { opts : [ ] } |&gt; Tesla . put_opt ( :option , &quot;value&quot; ) % Tesla.Env { opts : [ option : &quot;value&quot; ] }","ref":"Tesla.html#put_opt/3","title":"Tesla.put_opt/3","type":"function"},{"doc":"Perform a request. Options :method - the request method, one of [ :head , :get , :delete , :trace , :options , :post , :put , :patch ] :url - either full url e.g. &quot; http://example.com/some/path&quot; or just &quot;/some/path&quot; if using Tesla.Middleware.BaseUrl :query - a keyword list of query params, e.g. [page: 1, per_page: 100] :headers - a keyworld list of headers, e.g. [{&quot;content-type&quot;, &quot;text/plain&quot;}] :body - depends on used middleware: by default it can be a binary if using e.g. JSON encoding middleware it can be a nested map if adapter supports it it can be a Stream with any of the above :opts - custom, per-request middleware or adapter options Examples ExampleApi . request ( method : :get , url : &quot;/users/path&quot; ) # use shortcut methods ExampleApi . get ( &quot;/users/1&quot; ) ExampleApi . post ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } )","ref":"Tesla.html#request/2","title":"Tesla.request/2","type":"function"},{"doc":"Perform request and raise in case of error. This is similar to request/2 behaviour from Tesla 0.x See request/2 for list of available options.","ref":"Tesla.html#request!/2","title":"Tesla.request!/2","type":"function"},{"doc":"","ref":"Tesla.html#run/2","title":"Tesla.run/2","type":"function"},{"doc":"","ref":"Tesla.html#run_default_adapter/2","title":"Tesla.run_default_adapter/2","type":"function"},{"doc":"Perform a TRACE request. See request/1 or request/2 for options definition. trace ( &quot;/users&quot; ) trace ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) trace ( client , &quot;/users&quot; ) trace ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) trace ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Tesla.html#trace/3","title":"Tesla.trace/3","type":"function"},{"doc":"Perform a TRACE request. See request!/1 or request!/2 for options definition. trace! ( &quot;/users&quot; ) trace! ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) trace! ( client , &quot;/users&quot; ) trace! ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) trace! ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Tesla.html#trace!/3","title":"Tesla.trace!/3","type":"function"},{"doc":"Options that may be passed to a request function. See request/2 for detailed descriptions.","ref":"Tesla.html#t:option/0","title":"Tesla.option/0","type":"type"},{"doc":"","ref":"Tesla.Builder.html","title":"Tesla.Builder","type":"module"},{"doc":"","ref":"Tesla.Builder.html#adapter/1","title":"Tesla.Builder.adapter/1","type":"macro"},{"doc":"Choose adapter for your API client. defmodule ExampleApi do use Tesla # set adapter as module adapter Tesla.Adapter.Hackney # set adapter as anonymous function adapter fn env -&gt; ... env end end","ref":"Tesla.Builder.html#adapter/2","title":"Tesla.Builder.adapter/2","type":"macro"},{"doc":"","ref":"Tesla.Builder.html#client/3","title":"Tesla.Builder.client/3","type":"function"},{"doc":"","ref":"Tesla.Builder.html#plug/1","title":"Tesla.Builder.plug/1","type":"macro"},{"doc":"Attach middleware to your API client. defmodule ExampleApi do use Tesla # plug middleware module with options plug Tesla.Middleware.BaseUrl , &quot;http://api.example.com&quot; # or without options plug Tesla.Middleware.JSON # or a custom middleware plug MyProject.CustomMiddleware end","ref":"Tesla.Builder.html#plug/2","title":"Tesla.Builder.plug/2","type":"macro"},{"doc":"","ref":"Tesla.Client.html","title":"Tesla.Client","type":"module"},{"doc":"Returns the client's adapter in the same form it was provided. This can be used to copy an adapter from one client to another. Examples iex&gt; client = Tesla . client ( [ ] , { Tesla.Adapter.Hackney , [ recv_timeout : 30_000 ] } ) iex&gt; Tesla.Client . adapter ( client ) { Tesla.Adapter.Hackney , [ recv_timeout : 30_000 ] }","ref":"Tesla.Client.html#adapter/1","title":"Tesla.Client.adapter/1","type":"function"},{"doc":"Returns the client's middleware in the same form it was provided. This can be used to copy middleware from one client to another. Examples iex&gt; middleware = [ Tesla.Middleware.JSON , { Tesla.Middleware.BaseUrl , &quot;https://api.github.com&quot; } ] iex&gt; client = Tesla . client ( middleware ) iex&gt; Tesla.Client . middleware ( client ) [ Tesla.Middleware.JSON , { Tesla.Middleware.BaseUrl , &quot;https://api.github.com&quot; } ]","ref":"Tesla.Client.html#middleware/1","title":"Tesla.Client.middleware/1","type":"function"},{"doc":"","ref":"Tesla.Client.html#t:adapter/0","title":"Tesla.Client.adapter/0","type":"type"},{"doc":"","ref":"Tesla.Client.html#t:middleware/0","title":"Tesla.Client.middleware/0","type":"type"},{"doc":"","ref":"Tesla.Client.html#t:t/0","title":"Tesla.Client.t/0","type":"type"},{"doc":"This module defines a Tesla.Env.t/0 struct that stores all data related to request/response. Fields :method - method of request. Example: :get :url - request url. Example: &quot;https://www.google.com&quot; :query - list of query params. Example: [{&quot;param&quot;, &quot;value&quot;}] will be translated to ?params=value . Note: query params passed in url (e.g. &quot;/get?param=value&quot; ) are not parsed to query field. :headers - list of request/response headers. Example: [{&quot;content-type&quot;, &quot;application/json&quot;}] . Note: request headers are overridden by response headers when adapter is called. :body - request/response body. Note: request body is overridden by response body when adapter is called. :status - response status. Example: 200 :opts - list of options. Example: [adapter: [recv_timeout: 30_000]]","ref":"Tesla.Env.html","title":"Tesla.Env","type":"module"},{"doc":"","ref":"Tesla.Env.html#t:body/0","title":"Tesla.Env.body/0","type":"type"},{"doc":"","ref":"Tesla.Env.html#t:client/0","title":"Tesla.Env.client/0","type":"type"},{"doc":"","ref":"Tesla.Env.html#t:headers/0","title":"Tesla.Env.headers/0","type":"type"},{"doc":"","ref":"Tesla.Env.html#t:method/0","title":"Tesla.Env.method/0","type":"type"},{"doc":"","ref":"Tesla.Env.html#t:opts/0","title":"Tesla.Env.opts/0","type":"type"},{"doc":"","ref":"Tesla.Env.html#t:param/0","title":"Tesla.Env.param/0","type":"type"},{"doc":"","ref":"Tesla.Env.html#t:query/0","title":"Tesla.Env.query/0","type":"type"},{"doc":"","ref":"Tesla.Env.html#t:result/0","title":"Tesla.Env.result/0","type":"type"},{"doc":"","ref":"Tesla.Env.html#t:runtime/0","title":"Tesla.Env.runtime/0","type":"type"},{"doc":"","ref":"Tesla.Env.html#t:stack/0","title":"Tesla.Env.stack/0","type":"type"},{"doc":"","ref":"Tesla.Env.html#t:status/0","title":"Tesla.Env.status/0","type":"type"},{"doc":"","ref":"Tesla.Env.html#t:t/0","title":"Tesla.Env.t/0","type":"type"},{"doc":"","ref":"Tesla.Env.html#t:url/0","title":"Tesla.Env.url/0","type":"type"},{"doc":"Mock adapter for better testing. Setup # config/test.exs config :tesla , adapter : Tesla.Mock # in case MyClient defines specific adapter with `adapter SpecificAdapter` config :tesla , MyClient , adapter : Tesla.Mock Examples defmodule MyAppTest do use ExUnit.Case setup do Tesla.Mock . mock ( fn %{ method : :get } -&gt; % Tesla.Env { status : 200 , body : &quot;hello&quot; } end ) :ok end test &quot;list things&quot; do assert { :ok , env } = MyApp . get ( &quot;...&quot; ) assert env . status == 200 assert env . body == &quot;hello&quot; end end Setting up mocks # Match on method &amp; url and return whole Tesla.Env Tesla.Mock . mock ( fn %{ method : :get , url : &quot;http://example.com/list&quot; } -&gt; % Tesla.Env { status : 200 , body : &quot;hello&quot; } end ) # You can use any logic required Tesla.Mock . mock ( fn env -&gt; case env . url do &quot;http://example.com/list&quot; -&gt; % Tesla.Env { status : 200 , body : &quot;ok!&quot; } _ -&gt; % Tesla.Env { status : 404 , body : &quot;NotFound&quot; } end end ) # mock will also accept short version of response # in the form of {status, headers, body} Tesla.Mock . mock ( fn %{ method : :post } -&gt; { 201 , %{ } , %{ id : 42 } } end ) # mock will also accept error tuples in the form # of {:error, reason} Tesla.Mock . mock ( fn %{ method : :post } -&gt; { :error , :timeout } end ) Global mocks By default, mocks are bound to the current process, i.e. the process running a single test case. This design allows proper isolation between test cases and make testing in parallel ( async: true ) possible. While this style is recommended, there is one drawback: if Tesla client is called from different process it will not use the setup mock. To solve this issue it is possible to setup a global mock using mock_global/1 function. defmodule MyTest do use ExUnit.Case , async : false # must be false! setup_all do Tesla.Mock . mock_global fn env -&gt; # ... end :ok end # ... end WARNING : Using global mocks may affect tests with local mock (because of fallback to global mock in case local one is not found)","ref":"Tesla.Mock.html","title":"Tesla.Mock","type":"module"},{"doc":"","ref":"Tesla.Mock.html#call/2","title":"Tesla.Mock.call/2","type":"function"},{"doc":"Return JSON response. Example import Tesla.Mock mock fn %{ url : &quot;/ok&quot; } -&gt; json ( %{ &quot;some&quot; =&gt; &quot;data&quot; } ) %{ url : &quot;/404&quot; } -&gt; json ( %{ &quot;some&quot; =&gt; &quot;data&quot; } , status : 404 ) end","ref":"Tesla.Mock.html#json/2","title":"Tesla.Mock.json/2","type":"function"},{"doc":"Setup mocks for current test. This mock will only be available to the current process.","ref":"Tesla.Mock.html#mock/1","title":"Tesla.Mock.mock/1","type":"function"},{"doc":"Setup global mocks. WARNING : This mock will be available to ALL processes. It might cause conflicts when running tests in parallel!","ref":"Tesla.Mock.html#mock_global/1","title":"Tesla.Mock.mock_global/1","type":"function"},{"doc":"Return text response. Example import Tesla.Mock mock fn %{ url : &quot;/ok&quot; } -&gt; text ( %{ &quot;some&quot; =&gt; &quot;data&quot; } ) %{ url : &quot;/404&quot; } -&gt; text ( %{ &quot;some&quot; =&gt; &quot;data&quot; } , status : 404 ) end","ref":"Tesla.Mock.html#text/2","title":"Tesla.Mock.text/2","type":"function"},{"doc":"","ref":"Tesla.Mock.html#t:response_opt/0","title":"Tesla.Mock.response_opt/0","type":"type"},{"doc":"","ref":"Tesla.Mock.html#t:response_opts/0","title":"Tesla.Mock.response_opts/0","type":"type"},{"doc":"Multipart functionality. Examples mp = Multipart . new ( ) |&gt; Multipart . add_content_type_param ( &quot;charset=utf-8&quot; ) |&gt; Multipart . add_field ( &quot;field1&quot; , &quot;foo&quot; ) |&gt; Multipart . add_field ( &quot;field2&quot; , &quot;bar&quot; , headers : [ { &quot;content-id&quot; , &quot;1&quot; } , { &quot;content-type&quot; , &quot;text/plain&quot; } ] ) |&gt; Multipart . add_file ( &quot;test/tesla/multipart_test_file.sh&quot; ) |&gt; Multipart . add_file ( &quot;test/tesla/multipart_test_file.sh&quot; , name : &quot;foobar&quot; ) |&gt; Multipart . add_file_content ( &quot;sample file content&quot; , &quot;sample.txt&quot; ) response = client . post ( url , mp )","ref":"Tesla.Multipart.html","title":"Tesla.Multipart","type":"module"},{"doc":"Add a parameter to the multipart content-type.","ref":"Tesla.Multipart.html#add_content_type_param/2","title":"Tesla.Multipart.add_content_type_param/2","type":"function"},{"doc":"Add a field part.","ref":"Tesla.Multipart.html#add_field/4","title":"Tesla.Multipart.add_field/4","type":"function"},{"doc":"Add a file part. The file will be streamed. Options :name - name of form param :filename - filename (defaults to path basename) :headers - additional headers :detect_content_type - auto-detect file content-type (defaults to false)","ref":"Tesla.Multipart.html#add_file/3","title":"Tesla.Multipart.add_file/3","type":"function"},{"doc":"Add a file part with value. Same of add_file/3 but the file content is read from data input argument. Options :name - name of form param :headers - additional headers","ref":"Tesla.Multipart.html#add_file_content/4","title":"Tesla.Multipart.add_file_content/4","type":"function"},{"doc":"Create a new Multipart struct to be used for a request body.","ref":"Tesla.Multipart.html#new/0","title":"Tesla.Multipart.new/0","type":"function"},{"doc":"","ref":"Tesla.Multipart.html#t:part_stream/0","title":"Tesla.Multipart.part_stream/0","type":"type"},{"doc":"","ref":"Tesla.Multipart.html#t:part_value/0","title":"Tesla.Multipart.part_value/0","type":"type"},{"doc":"","ref":"Tesla.Multipart.html#t:t/0","title":"Tesla.Multipart.t/0","type":"type"},{"doc":"Encode requests and decode responses as MessagePack. This middleware requires Msgpax as dependency. Remember to add {:msgpax, &quot;&gt;= 2.3.0&quot;} to dependencies. Also, you need to recompile Tesla after adding :msgpax dependency: mix deps . clean tesla mix deps . compile tesla Examples defmodule MyClient do use Tesla plug Tesla.Middleware.MessagePack # or plug Tesla.Middleware.MessagePack , engine_opts : [ binary : true ] # or plug Tesla.Middleware.MessagePack , decode : &amp; Custom . decode / 1 , encode : &amp; Custom . encode / 1 end Options :decode - decoding function :encode - encoding function :encode_content_type - content-type to be used in request header :decode_content_types - list of additional decodable content-types :engine_opts - optional engine options","ref":"Tesla.Middleware.MessagePack.html","title":"Tesla.Middleware.MessagePack","type":"module"},{"doc":"Decode response body as MessagePack. It is used by Tesla.Middleware.DecodeMessagePack .","ref":"Tesla.Middleware.MessagePack.html#decode/2","title":"Tesla.Middleware.MessagePack.decode/2","type":"function"},{"doc":"Encode request body as MessagePack. It is used by Tesla.Middleware.EncodeMessagePack .","ref":"Tesla.Middleware.MessagePack.html#encode/2","title":"Tesla.Middleware.MessagePack.encode/2","type":"function"},{"doc":"The adapter specification. Adapter is a module that denormalize request data stored in Tesla.Env in order to make request with lower level http client (e.g. :httpc or :hackney ) and normalize response data in order to store it back to Tesla.Env . It has to implement Tesla.Adapter.call/2 . Writing custom adapter Create a module implementing Tesla.Adapter.call/2 . See Tesla.Adapter.call/2 for details. Examples defmodule MyProject.CustomAdapter do alias Tesla.Multipart @behaviour Tesla.Adapter @override_defaults [ follow_redirect : false ] @impl Tesla.Adapter def call ( env , opts ) do opts = Tesla.Adapter . opts ( @override_defaults , env , opts ) with { :ok , { status , headers , body } } &lt;- request ( env . method , env . body , env . headers , opts ) do { :ok , normalize_response ( env , status , headers , body ) } end end defp request ( _method , % Stream { } , _headers , _opts ) do { :error , &quot;stream not supported by adapter&quot; } end defp request ( _method , % Multipart { } , _headers , _opts ) do { :error , &quot;multipart not supported by adapter&quot; } end defp request ( method , body , headers , opts ) do :lower_level_http . request ( method , body , denormalize_headers ( headers ) , opts ) end defp denormalize_headers ( headers ) , do : ... defp normalize_response ( env , status , headers , body ) , do : % Tesla.Env { env | ... } end","ref":"Tesla.Adapter.html","title":"Tesla.Adapter","type":"behaviour"},{"doc":"Invoked when a request runs. Arguments env - Tesla.Env struct that stores request/response data options - middleware options provided by user","ref":"Tesla.Adapter.html#c:call/2","title":"Tesla.Adapter.call/2","type":"callback"},{"doc":"Helper function that merges all adapter options. Arguments defaults (optional) - useful to override lower level http client default configuration env - Tesla.Env struct opts - options provided to Tesla.Builder.adapter/2 macro Precedence rules config from opts overrides config from defaults when same key is encountered config from env overrides config from both defaults and opts when same key is encountered","ref":"Tesla.Adapter.html#opts/3","title":"Tesla.Adapter.opts/3","type":"function"},{"doc":"The middleware specification. Middleware is an extension of basic Tesla functionality. It is a module that must implement Tesla.Middleware.call/3 . Middleware options Options can be passed to middleware in second param of Tesla.Builder.plug/2 macro: plug Tesla.Middleware.BaseUrl , &quot;https://example.com&quot; or inside tuple in case of dynamic middleware ( Tesla.client/1 ): Tesla . client ( [ { Tesla.Middleware.BaseUrl , &quot;https://example.com&quot; } ] ) Writing custom middleware Writing custom middleware is as simple as creating a module implementing Tesla.Middleware.call/3 . See Tesla.Middleware.call/3 for details. Examples defmodule MyProject.InspectHeadersMiddleware do @behaviour Tesla.Middleware @impl true def call ( env , next , _options ) do IO . inspect ( env . headers ) with { :ok , env } &lt;- Tesla . run ( env , next ) do IO . inspect ( env . headers ) { :ok , env } end end end","ref":"Tesla.Middleware.html","title":"Tesla.Middleware","type":"behaviour"},{"doc":"Invoked when a request runs. (optionally) read and/or writes request data calls Tesla.run/2 (optionally) read and/or writes response data Arguments env - Tesla.Env struct that stores request/response data next - middlewares that should be called after current one options - middleware options provided by user","ref":"Tesla.Middleware.html#c:call/3","title":"Tesla.Middleware.call/3","type":"callback"},{"doc":"Adapter for finch . Remember to add {:finch, &quot;~&gt; 0.3&quot;} to dependencies. Also, you need to recompile tesla after adding the :finch dependency: mix deps . clean tesla mix compile Examples In order to use Finch, you must start it and provide a :name . For example, in your supervision tree: children = [ { Finch , name : MyFinch } ] You must provide the same name to this adapter: # set globally in config/config.exs config :tesla , :adapter , { Tesla.Adapter.Finch , name : MyFinch } # set per module defmodule MyClient do use Tesla adapter Tesla.Adapter.Finch , name : MyFinch end Adapter specific options :name - The :name provided to Finch ( required ). Finch options :pool_timeout - This timeout is applied when a connection is checked out from the pool. Default value is 5_000 . :receive_timeout - The maximum time to wait for a response before returning an error. Default value is 15_000 .","ref":"Tesla.Adapter.Finch.html","title":"Tesla.Adapter.Finch","type":"module"},{"doc":"Adapter for gun . Remember to add {:gun, &quot;~&gt; 1.3&quot;} , {:idna, &quot;~&gt; 6.0&quot;} and {:castore, &quot;~&gt; 0.1&quot;} to dependencies. In version 1.3 gun sends host header with port. Fixed in master branch. Also, you need to recompile tesla after adding :gun dependency: mix deps . clean tesla mix deps . compile tesla Examples # set globally in config/config.exs config :tesla , :adapter , Tesla.Adapter.Gun # set per module defmodule MyClient do use Tesla adapter Tesla.Adapter.Gun end Adapter specific options :timeout - Time, while process, will wait for gun messages. :body_as - What will be returned in %Tesla.Env{} body key. Possible values: :plain - as binary (default). :stream - as stream. If you don't want to close connection (because you want to reuse it later) pass close_conn: false in adapter opts. :chunks - as chunks. You can get response body in chunks using Tesla.Adapter.Gun.read_chunk/3 function. Processing of the chunks and checking body size must be done by yourself. Example of processing function is in test/tesla/adapter/gun_test.exs - Tesla.Adapter.GunTest.read_body/4 . If you don't need connection later don't forget to close it with Tesla.Adapter.Gun.close/1 . :max_body - Max response body size in bytes. Works only with body_as: :plain , with other settings you need to check response body size by yourself. :conn - Opened connection pid with gun. Is used for reusing gun connections. :close_conn - Close connection or not after receiving full response body. Is used for reusing gun connections. Defaults to true . :certificates_verification - Add SSL certificates verification. erlang-certifi ssl_verify_fun.erl :proxy - Proxy for requests. Socks proxy are supported only for gun master branch . Examples: {'localhost', 1234} , {{127, 0, 0, 1}, 1234} , {:socks5, 'localhost', 1234} . NOTE: By default GUN uses TLS as transport if the specified port is 443, if TLS is required for proxy connection on another port please specify transport using the Gun options below otherwise tcp will be used. :proxy_auth - Auth to be passed along with the proxy opt. Supports Basic auth for regular and Socks proxy. Format: {proxy_username, proxy_password} . Gun options :connect_timeout - Connection timeout. :http_opts - Options specific to the HTTP protocol. :http2_opts - Options specific to the HTTP/2 protocol. :protocols - Ordered list of preferred protocols. Defaults: [:http2, :http] - for :tls, [:http] - for :tcp. :trace - Whether to enable dbg tracing of the connection process. Should only be used during debugging. Default: false. :transport - Whether to use TLS or plain TCP. The default varies depending on the port used. Port 443 defaults to tls. All other ports default to tcp. :transport_opts - Transport options. They are TCP options or TLS options depending on the selected transport. Default: [] . Gun version: 1.3. :tls_opts - TLS transport options. Default: [] . Gun from master branch. :tcp_opts - TCP transport options. Default: [] . Gun from master branch. :socks_opts - Options for socks. Default: [] . Gun from master branch. :ws_opts - Options specific to the Websocket protocol. Default: %{} . :compress - Whether to enable permessage-deflate compression. This does not guarantee that compression will be used as it is the server that ultimately decides. Defaults to false. :protocols - A non-empty list enables Websocket protocol negotiation. The list of protocols will be sent in the sec-websocket-protocol request header. The handler module interface is currently undocumented and must be set to gun_ws_h .","ref":"Tesla.Adapter.Gun.html","title":"Tesla.Adapter.Gun","type":"module"},{"doc":"Brutally close the gun connection.","ref":"Tesla.Adapter.Gun.html#close/1","title":"Tesla.Adapter.Gun.close/1","type":"function"},{"doc":"Reads chunk of the response body. Returns {:fin, binary()} if all body received, otherwise returns {:nofin, binary()} .","ref":"Tesla.Adapter.Gun.html#read_chunk/3","title":"Tesla.Adapter.Gun.read_chunk/3","type":"function"},{"doc":"Adapter for hackney . Remember to add {:hackney, &quot;~&gt; 1.13&quot;} to dependencies (and :hackney to applications in mix.exs ) Also, you need to recompile tesla after adding :hackney dependency: mix deps . clean tesla mix deps . compile tesla Examples # set globally in config/config.exs config :tesla , :adapter , Tesla.Adapter.Hackney # set per module defmodule MyClient do use Tesla adapter Tesla.Adapter.Hackney end Adapter specific options :max_body - Max response body size in bytes. Actual response may be bigger because hackney stops after the last chunk that surpasses :max_body .","ref":"Tesla.Adapter.Hackney.html","title":"Tesla.Adapter.Hackney","type":"module"},{"doc":"Adapter for httpc . This is the default adapter. NOTE Tesla overrides default autoredirect value with false to ensure consistency between adapters","ref":"Tesla.Adapter.Httpc.html","title":"Tesla.Adapter.Httpc","type":"module"},{"doc":"Adapter for ibrowse . Remember to add {:ibrowse, &quot;~&gt; 4.2&quot;} to dependencies (and :ibrowse to applications in mix.exs ) Also, you need to recompile tesla after adding :ibrowse dependency: mix deps . clean tesla mix deps . compile tesla Examples # set globally in config/config.exs config :tesla , :adapter , Tesla.Adapter.Ibrowse # set per module defmodule MyClient do use Tesla adapter Tesla.Adapter.Ibrowse end","ref":"Tesla.Adapter.Ibrowse.html","title":"Tesla.Adapter.Ibrowse","type":"module"},{"doc":"Adapter for mint . NOTE: The minimum supported Elixir version for mint is 1.5.0 Remember to add {:mint, &quot;~&gt; 1.0&quot;} and {:castore, &quot;~&gt; 0.1&quot;} to dependencies. Also, you need to recompile tesla after adding :mint dependency: mix deps . clean tesla mix deps . compile tesla Examples # set globally in config/config.exs config :tesla , :adapter , Tesla.Adapter.Mint # set per module defmodule MyClient do use Tesla adapter Tesla.Adapter.Mint end # set global custom cacertfile config :tesla , adapter : { Tesla.Adapter.Mint , cacert : [ &quot;path_to_cacert&quot; ] } Adapter specific options: :timeout - Time in milliseconds, while process, will wait for mint messages. Defaults to 2_000 . :body_as - What will be returned in %Tesla.Env{} body key. Possible values - :plain , :stream , :chunks . Defaults to :plain . :plain - as binary. :stream - as stream. If you don't want to close connection (because you want to reuse it later) pass close_conn: false in adapter opts. :chunks - as chunks. You can get response body in chunks using Tesla.Adapter.Mint.read_chunk/3 function. Processing of the chunks and checking body size must be done by yourself. Example of processing function is in test/tesla/adapter/mint_test.exs - Tesla.Adapter.MintTest.read_body/4 . If you don't need connection later don't forget to close it with Tesla.Adapter.Mint.close/1 . :max_body - Max response body size in bytes. Works only with body_as: :plain , with other settings you need to check response body size by yourself. :conn - Opened connection with mint. Is used for reusing mint connections. :original - Original host with port, for which reused connection was open. Needed for Tesla.Middleware.FollowRedirects . Otherwise adapter will use connection for another open host. :close_conn - Close connection or not after receiving full response body. Is used for reusing mint connections. Defaults to true . :proxy - Proxy settings. E.g.: {:http, &quot;localhost&quot;, 8888, []} , {:http, &quot;127.0.0.1&quot;, 8888, []}","ref":"Tesla.Adapter.Mint.html","title":"Tesla.Adapter.Mint","type":"module"},{"doc":"Closes mint connection.","ref":"Tesla.Adapter.Mint.html#close/1","title":"Tesla.Adapter.Mint.close/1","type":"function"},{"doc":"Reads chunk of the response body. Returns {:fin, HTTP.t(), binary()} if all body received, otherwise returns {:nofin, HTTP.t(), binary()} .","ref":"Tesla.Adapter.Mint.html#read_chunk/3","title":"Tesla.Adapter.Mint.read_chunk/3","type":"function"},{"doc":"Set base URL for all requests. The base URL will be prepended to request path/URL only if it does not include http(s). Examples defmodule MyClient do use Tesla plug Tesla.Middleware.BaseUrl , &quot;https://example.com/foo&quot; end MyClient . get ( &quot;/path&quot; ) # equals to GET https://example.com/foo/path MyClient . get ( &quot;path&quot; ) # equals to GET https://example.com/foo/path MyClient . get ( &quot;&quot; ) # equals to GET https://example.com/foo MyClient . get ( &quot;http://example.com/bar&quot; ) # equals to GET http://example.com/bar","ref":"Tesla.Middleware.BaseUrl.html","title":"Tesla.Middleware.BaseUrl","type":"module"},{"doc":"Basic authentication middleware. Wiki on the topic Examples defmodule MyClient do use Tesla # static configuration plug Tesla.Middleware.BasicAuth , username : &quot;user&quot; , password : &quot;pass&quot; # dynamic user &amp; pass def new ( username , password , opts \\\\ %{ } ) do Tesla . client [ { Tesla.Middleware.BasicAuth , Map . merge ( %{ username : username , password : password } , opts ) } ] end end Options :username - username (defaults to &quot;&quot; ) :password - password (defaults to &quot;&quot; )","ref":"Tesla.Middleware.BasicAuth.html","title":"Tesla.Middleware.BasicAuth","type":"module"},{"doc":"Bearer authentication middleware. Adds a {&quot;authorization&quot;, &quot;Bearer &lt;token&gt;&quot;} header. Examples defmodule MyClient do use Tesla # static configuration plug Tesla.Middleware.BearerAuth , token : &quot;token&quot; # dynamic token def new ( token ) do Tesla . client [ { Tesla.Middleware.BearerAuth , token : token } ] end end Options :token - token (defaults to &quot;&quot; )","ref":"Tesla.Middleware.BearerAuth.html","title":"Tesla.Middleware.BearerAuth","type":"module"},{"doc":"Only compress request. See Tesla.Middleware.Compression for options.","ref":"Tesla.Middleware.CompressRequest.html","title":"Tesla.Middleware.CompressRequest","type":"module"},{"doc":"Compress requests and decompress responses. Supports &quot;gzip&quot; and &quot;deflate&quot; encodings using Erlang's built-in :zlib module. Examples defmodule MyClient do use Tesla plug Tesla.Middleware.Compression , format : &quot;gzip&quot; end Options :format - request compression format, &quot;gzip&quot; (default) or &quot;deflate&quot;","ref":"Tesla.Middleware.Compression.html","title":"Tesla.Middleware.Compression","type":"module"},{"doc":"Compress request. It is used by Tesla.Middleware.CompressRequest .","ref":"Tesla.Middleware.Compression.html#compress/2","title":"Tesla.Middleware.Compression.compress/2","type":"function"},{"doc":"Decompress response. It is used by Tesla.Middleware.DecompressResponse .","ref":"Tesla.Middleware.Compression.html#decompress/1","title":"Tesla.Middleware.Compression.decompress/1","type":"function"},{"doc":"","ref":"Tesla.Middleware.DecodeFormUrlencoded.html","title":"Tesla.Middleware.DecodeFormUrlencoded","type":"module"},{"doc":"Decode Link Hypermedia HTTP header into opts[:rels] field in response. Examples defmodule MyClient do use Tesla plug Tesla.Middleware.DecodeRels end env = MyClient . get ( &quot;/...&quot; ) env . opts [ :rels ] # =&gt; %{&quot;Next&quot; =&gt; &quot;http://...&quot;, &quot;Prev&quot; =&gt; &quot;...&quot;}","ref":"Tesla.Middleware.DecodeRels.html","title":"Tesla.Middleware.DecodeRels","type":"module"},{"doc":"Only decompress response. See Tesla.Middleware.Compression for options.","ref":"Tesla.Middleware.DecompressResponse.html","title":"Tesla.Middleware.DecompressResponse","type":"module"},{"doc":"Digest access authentication middleware. Wiki on the topic NOTE : Currently the implementation is incomplete and works only for MD5 algorithm and auth &quot;quality of protection&quot; (qop). Examples defmodule MyClient do use Tesla def client ( username , password , opts \\ %{ } ) do Tesla . client ( [ { Tesla.Middleware.DigestAuth , Map . merge ( %{ username : username , password : password } , opts ) } ] ) end end Options :username - username (defaults to &quot;&quot; ) :password - password (defaults to &quot;&quot; ) :cnonce_fn - custom function generating client nonce (defaults to &amp;Tesla.Middleware.DigestAuth.cnonce/0 ) :nc - nonce counter (defaults to &quot;00000000&quot; )","ref":"Tesla.Middleware.DigestAuth.html","title":"Tesla.Middleware.DigestAuth","type":"module"},{"doc":"","ref":"Tesla.Middleware.EncodeFormUrlencoded.html","title":"Tesla.Middleware.EncodeFormUrlencoded","type":"module"},{"doc":"Follow HTTP 3xx redirects. Examples defmodule MyClient do use Tesla plug Tesla.Middleware.FollowRedirects , max_redirects : 3 # defaults to 5 end Options :max_redirects - limit number of redirects (default: 5 )","ref":"Tesla.Middleware.FollowRedirects.html","title":"Tesla.Middleware.FollowRedirects","type":"module"},{"doc":"Send request body as application/x-www-form-urlencoded . Performs encoding of body from a Map such as %{&quot;foo&quot; =&gt; &quot;bar&quot;} into url encoded data. Performs decoding of the response into a map when urlencoded and content-type is application/x-www-form-urlencoded , so &quot;foo=bar&quot; becomes %{&quot;foo&quot; =&gt; &quot;bar&quot;} . Examples defmodule Myclient do use Tesla plug Tesla.Middleware.FormUrlencoded end Myclient . post ( &quot;/url&quot; , %{ key : :value } ) Options :decode - decoding function, defaults to URI.decode_query/1 :encode - encoding function, defaults to URI.encode_query/1 Nested Maps Natively, nested maps are not supported in the body, so %{&quot;foo&quot; =&gt; %{&quot;bar&quot; =&gt; &quot;baz&quot;}} won't be encoded and raise an error. Support for this specific case is obtained by configuring the middleware to encode (and decode) with Plug.Conn.Query defmodule Myclient do use Tesla plug Tesla.Middleware.FormUrlencoded , encode : &amp; Plug.Conn.Query . encode / 1 , decode : &amp; Plug.Conn.Query . decode / 1 end Myclient . post ( &quot;/url&quot; , %{ key : %{ nested : &quot;value&quot; } } )","ref":"Tesla.Middleware.FormUrlencoded.html","title":"Tesla.Middleware.FormUrlencoded","type":"module"},{"doc":"Decode response body as querystring. It is used by Tesla.Middleware.DecodeFormUrlencoded .","ref":"Tesla.Middleware.FormUrlencoded.html#decode/2","title":"Tesla.Middleware.FormUrlencoded.decode/2","type":"function"},{"doc":"Encode response body as querystring. It is used by Tesla.Middleware.EncodeFormUrlencoded .","ref":"Tesla.Middleware.FormUrlencoded.html#encode/2","title":"Tesla.Middleware.FormUrlencoded.encode/2","type":"function"},{"doc":"Circuit Breaker middleware using fuse . Remember to add {:fuse, &quot;~&gt; 2.4&quot;} to dependencies (and :fuse to applications in mix.exs ) Also, you need to recompile tesla after adding :fuse dependency: mix deps . clean tesla mix deps . compile tesla Examples defmodule MyClient do use Tesla plug Tesla.Middleware.Fuse , opts : { { :standard , 2 , 10_000 } , { :reset , 60_000 } } , keep_original_error : true , should_melt : fn { :ok , %{ status : status } } when status in [ 428 , 500 , 504 ] -&gt; true { :ok , _ } -&gt; false { :error , _ } -&gt; true end , mode : :sync end Options :name - fuse name (defaults to module name) :opts - fuse options (see fuse docs for reference) :keep_original_error - boolean to indicate if, in case of melting (based on should_melt ), it should return the upstream's error or the fixed one {:error, unavailable} . It's false by default, but it will be true in 2.0.0 version :should_melt - function to determine if response should melt the fuse :mode - how to query the fuse, which has two values: :sync - queries are serialized through the :fuse_server process (the default) :async_dirty - queries check the fuse state directly, but may not account for recent melts or resets SASL logger fuse library uses SASL (System Architecture Support Libraries) . You can disable its logger output using: config :sasl , sasl_error_logger : :false Read more at jlouis/fuse#32 and jlouis/fuse#19 .","ref":"Tesla.Middleware.Fuse.html","title":"Tesla.Middleware.Fuse","type":"module"},{"doc":"Set default headers for all requests Examples defmodule Myclient do use Tesla plug Tesla.Middleware.Headers , [ { &quot;user-agent&quot; , &quot;Tesla&quot; } ] end","ref":"Tesla.Middleware.Headers.html","title":"Tesla.Middleware.Headers","type":"module"},{"doc":"Encode requests and decode responses as JSON. This middleware requires Jason (or other engine) as dependency. Remember to add {:jason, &quot;&gt;= 1.0&quot;} to dependencies. Also, you need to recompile Tesla after adding :jason dependency: mix deps . clean tesla mix deps . compile tesla Examples defmodule MyClient do use Tesla plug Tesla.Middleware.JSON # use jason engine # or plug Tesla.Middleware.JSON , engine : JSX , engine_opts : [ strict : [ :comments ] ] # or plug Tesla.Middleware.JSON , engine : Poison , engine_opts : [ keys : :atoms ] # or plug Tesla.Middleware.JSON , decode : &amp; JSX . decode / 1 , encode : &amp; JSX . encode / 1 end Options :decode - decoding function :encode - encoding function :encode_content_type - content-type to be used in request header :engine - encode/decode engine, e.g Jason , Poison or JSX (defaults to Jason) :engine_opts - optional engine options :decode_content_types - list of additional decodable content-types","ref":"Tesla.Middleware.JSON.html","title":"Tesla.Middleware.JSON","type":"module"},{"doc":"Decode response body as JSON. It is used by Tesla.Middleware.DecodeJson .","ref":"Tesla.Middleware.JSON.html#decode/2","title":"Tesla.Middleware.JSON.decode/2","type":"function"},{"doc":"Encode request body as JSON. It is used by Tesla.Middleware.EncodeJson .","ref":"Tesla.Middleware.JSON.html#encode/2","title":"Tesla.Middleware.JSON.encode/2","type":"function"},{"doc":"Store request url ,body and headers into :opts . Examples defmodule MyClient do use Tesla plug Tesla.Middleware.KeepRequest plug Tesla.Middleware.PathParams end { :ok , env } = MyClient . post ( &quot;/users/:user_id&quot; , &quot;request-data&quot; , opts : [ path_params : [ user_id : &quot;1234]]) env.body # =&gt; &quot; response - data &quot; env.opts[:req_body] # =&gt; &quot; request - data &quot; env.opts[:req_headers] # =&gt; [{&quot; request - headers &quot;, &quot; are - safe &quot;}, ...] env.opts[:req_url] # =&gt; &quot; http :/ / localhost : 8000 / users / :user_id","ref":"Tesla.Middleware.KeepRequest.html","title":"Tesla.Middleware.KeepRequest","type":"module"},{"doc":"Log requests using Elixir's Logger. With the default settings it logs request method, URL, response status, and time taken in milliseconds. Examples defmodule MyClient do use Tesla plug Tesla.Middleware.Logger end Options :log_level - custom function for calculating log level (see below) :filter_headers - sanitizes sensitive headers before logging in debug mode (see below) :debug - show detailed request/response logging :format - custom string template or function for log message (see below) Custom log format The default log format is &quot;$method $url -&gt; $status ($time ms)&quot; which shows in logs like: 2018 - 03 - 25 18 : 32 : 40.397 [ info ] GET https :/ / bitebot . io -&gt; 200 ( 88.074 ms ) It can be changed globally with config: config :tesla , Tesla.Middleware.Logger , format : &quot;$method $url ====&gt; $status / time=$time&quot; Or you can customize this setting by providing your own format function: defmodule MyClient do use Tesla plug Tesla.Middleware.Logger , format : &amp; my_format / 3 def my_format ( request , response , time ) do &quot;request= \#{ inspect ( request ) } response= \#{ inspect ( response ) } time= \#{ time } \\n &quot; end end Custom log levels By default, the following log levels will be used: :error - for errors, 5xx and 4xx responses :warn - for 3xx responses :info - for 2xx responses You can customize this setting by providing your own log_level/1 function: defmodule MyClient do use Tesla plug Tesla.Middleware.Logger , log_level : &amp; my_log_level / 1 def my_log_level ( env ) do case env . status do 404 -&gt; :info _ -&gt; :default end end end Logger Debug output When the Elixir Logger log level is set to :debug Tesla Logger will show full request &amp; response. If you want to disable detailed request/response logging but keep the :debug log level (i.e. in development) you can set debug: false in your config: # config/dev.local.exs config :tesla , Tesla.Middleware.Logger , debug : false Note that the logging configuration is evaluated at compile time, so Tesla must be recompiled for the configuration to take effect: mix deps . clean -- build tesla mix deps . compile tesla In order to be able to set :debug at runtime we can pass it as a option to the middleware at runtime. def client do middleware = [ # ... { Tesla.Middleware.Logger , debug : false } ] Tesla . client ( middleware ) end Filter headers To sanitize sensitive headers such as authorization in debug logs, add them to the :filter_headers option. :filter_headers expects a list of header names as strings. # config/dev.local.exs config :tesla , Tesla.Middleware.Logger , filter_headers : [ &quot;authorization&quot; ]","ref":"Tesla.Middleware.Logger.html","title":"Tesla.Middleware.Logger","type":"module"},{"doc":"","ref":"Tesla.Middleware.Logger.html#default_log_level/1","title":"Tesla.Middleware.Logger.default_log_level/1","type":"function"},{"doc":"","ref":"Tesla.Middleware.Logger.html#t:log_level/0","title":"Tesla.Middleware.Logger.log_level/0","type":"type"},{"doc":"Middleware that adds X-HTTP-Method-Override header with original request method and sends the request as post. Useful when there's an issue with sending non-POST request. Examples defmodule MyClient do use Tesla plug Tesla.Middleware.MethodOverride end Options :override - list of HTTP methods that should be overridden, everything except :get and :post if not specified","ref":"Tesla.Middleware.MethodOverride.html","title":"Tesla.Middleware.MethodOverride","type":"module"},{"doc":"Set default opts for all requests. Examples defmodule Myclient do use Tesla plug Tesla.Middleware.Opts , [ some : &quot;option&quot; ] end","ref":"Tesla.Middleware.Opts.html","title":"Tesla.Middleware.Opts","type":"module"},{"doc":"Use templated URLs with separate params. Useful when logging or reporting metric per URL. Examples defmodule MyClient do use Tesla plug Tesla.Middleware.BaseUrl , &quot;https://api.example.com&quot; plug Tesla.Middleware.Logger # or some monitoring middleware plug Tesla.Middleware.PathParams def user ( id ) do params = [ id : id ] get ( &quot;/users/:id&quot; , opts : [ path_params : params ] ) end end","ref":"Tesla.Middleware.PathParams.html","title":"Tesla.Middleware.PathParams","type":"module"},{"doc":"Set default query params for all requests Examples defmodule Myclient do use Tesla plug Tesla.Middleware.Query , [ token : &quot;some-token&quot; ] end","ref":"Tesla.Middleware.Query.html","title":"Tesla.Middleware.Query","type":"module"},{"doc":"Retry using exponential backoff and full jitter. By defaults, this middleware only retries in the case of connection errors ( nxdomain , connrefused , etc). Application error checking for retry can be customized through :should_retry option. Backoff algorithm The backoff algorithm optimizes for tight bounds on completing a request successfully. It does this by first calculating an exponential backoff factor based on the number of retries that have been performed. It then multiplies this factor against the base delay. The total maximum delay is found by taking the minimum of either the calculated delay or the maximum delay specified. This creates an upper bound on the maximum delay we can see. In order to find the actual delay value we apply additive noise which is proportional to the current desired delay. This ensures that the actual delay is kept within the expected order of magnitude, while still having some randomness, which ensures that our retried requests don't &quot;harmonize&quot; making it harder for the downstream service to heal. Examples defmodule MyClient do use Tesla plug Tesla.Middleware.Retry , delay : 500 , max_retries : 10 , max_delay : 4_000 , should_retry : fn { :ok , %{ status : status } } when status in [ 400 , 500 ] -&gt; true { :ok , _ } -&gt; false { :error , _ } -&gt; true end end Options :delay - The base delay in milliseconds (positive integer, defaults to 50) :max_retries - maximum number of retries (non-negative integer, defaults to 5) :max_delay - maximum delay in milliseconds (positive integer, defaults to 5000) :should_retry - function to determine if request should be retried :jitter_factor - additive noise proportionality constant (float between 0 and 1, defaults to 0.2)","ref":"Tesla.Middleware.Retry.html","title":"Tesla.Middleware.Retry","type":"module"},{"doc":"Emits events using the :telemetry library to expose instrumentation. Examples defmodule MyClient do use Tesla plug Tesla.Middleware.Telemetry end :telemetry . attach ( &quot;my-tesla-telemetry&quot; , [ :tesla , :request , :stop ] , fn event , measurements , meta , config -&gt; # Do something with the event end , nil ) Options :metadata - additional metadata passed to telemetry events Telemetry Events [:tesla, :request, :start] - emitted at the beginning of the request. Measurement: %{system_time: System.system_time()} Metadata: %{env: Tesla.Env.t()} [:tesla, :request, :stop] - emitted at the end of the request. Measurement: %{duration: native_time} Metadata: %{env: Tesla.Env.t()} | %{env: Tesla.Env.t(), error: term()} [:tesla, :request, :exception] - emitted when an exception has been raised. Measurement: %{duration: native_time} Metadata: %{env: Tesla.Env.t(), kind: Exception.kind(), reason: term(), stacktrace: Exception.stacktrace()} Legacy Telemetry Events [:tesla, :request] - This event is emitted for backwards compatibility only and should be considered deprecated. This event can be disabled by setting config :tesla, Tesla.Middleware.Telemetry, disable_legacy_event: true in your config. Be sure to run mix deps.compile --force tesla after changing this setting to ensure the change is picked up. Please check the telemetry for the further usage. URL event scoping with Tesla.Middleware.PathParams and Tesla.Middleware.KeepRequest Sometimes, it is useful to have access to a template url (i.e. &quot;/users/:user_id&quot; ) for grouping Telemetry events. For such cases, a combination of the Tesla.Middleware.PathParams , Tesla.Middleware.Telemetry and Tesla.Middleware.KeepRequest may be used. defmodule MyClient do use Tesla # The KeepRequest middleware sets the template url as a Tesla.Env.opts entry # Said entry must be used because on happy-path scenarios, # the Telemetry middleware will receive the Tesla.Env.url resolved by PathParams. plug Tesla.Middleware.KeepRequest plug Tesla.Middleware.Telemetry plug Tesla.Middleware.PathParams end :telemetry . attach ( &quot;my-tesla-telemetry&quot; , [ :tesla , :request , :stop ] , fn event , measurements , meta , config -&gt; path_params_template_url = meta . env . opts [ :req_url ] # The meta.env.url key will only present the resolved URL on happy-path scenarios. # Error cases will still return the original template url. path_params_resolved_url = meta . env . url end , nil )","ref":"Tesla.Middleware.Telemetry.html","title":"Tesla.Middleware.Telemetry","type":"module"},{"doc":"Timeout HTTP request after X milliseconds. Examples defmodule MyClient do use Tesla plug Tesla.Middleware.Timeout , timeout : 2_000 end Options :timeout - number of milliseconds a request is allowed to take (defaults to 1000 )","ref":"Tesla.Middleware.Timeout.html","title":"Tesla.Middleware.Timeout","type":"module"},{"doc":"","ref":"Tesla.Error.html","title":"Tesla.Error","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"Tesla.Error.html#message/1","title":"Tesla.Error.message/1","type":"function"},{"doc":"","ref":"Tesla.Mock.Error.html","title":"Tesla.Mock.Error","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"Tesla.Mock.Error.html#message/1","title":"Tesla.Mock.Error.message/1","type":"function"},{"doc":"Tesla Tesla is an HTTP client loosely based on Faraday . It embraces the concept of middleware when processing the request/response cycle. Note that this README refers to the master branch of Tesla, not the latest released version on Hex. See the documentation for the documentation of the version you're using. For the list of changes, checkout the latest release notes .","ref":"readme.html","title":"Tesla","type":"extras"},{"doc":"Define module with use Tesla and choose from a variety of middleware. defmodule GitHub do use Tesla plug Tesla.Middleware.BaseUrl , &quot;https://api.github.com&quot; plug Tesla.Middleware.Headers , [ { &quot;authorization&quot; , &quot;token xyz&quot; } ] plug Tesla.Middleware.JSON def user_repos ( login ) do get ( &quot;/users/&quot; &lt;&gt; login &lt;&gt; &quot;/repos&quot; ) end end Then use it like this: { :ok , response } = GitHub . user_repos ( &quot;teamon&quot; ) response . status # =&gt; 200 response . body # =&gt; [%{…}, …] response . headers # =&gt; [{&quot;content-type&quot;, &quot;application/json&quot;}, ...] See below for documentation.","ref":"readme.html#http-client-example","title":"Tesla - HTTP Client example","type":"extras"},{"doc":"Add :tesla as dependency in mix.exs : defp deps do [ { :tesla , &quot;~&gt; 1.4&quot; } , # optional, but recommended adapter { :hackney , &quot;~&gt; 1.17&quot; } , # optional, required by JSON middleware { :jason , &quot;&gt;= 1.0.0&quot; } ] end Tesla uses Semantic Versioning 2.0. Configure default adapter in config/config.exs (optional). # config/config.exs config :tesla , adapter : Tesla.Adapter.Hackney The default adapter is erlang's built-in httpc , but it is not recommended to use it in production environment as it does not validate SSL certificates among other issues .","ref":"readme.html#installation","title":"Tesla - Installation","type":"extras"},{"doc":"Middleware Runtime middleware Adapters Streaming Multipart Testing Writing middleware Direct usage Cheatsheet Cookbook Changelog","ref":"readme.html#documentation","title":"Tesla - Documentation","type":"extras"},{"doc":"Tesla is built around the concept of composable middlewares. This is very similar to how Plug Router works. Basic Tesla.Middleware.BaseUrl - set base url Tesla.Middleware.Headers - set request headers Tesla.Middleware.Query - set query parameters Tesla.Middleware.Opts - set request options Tesla.Middleware.FollowRedirects - follow HTTP 3xx redirects Tesla.Middleware.MethodOverride - set X-Http-Method-Override header Tesla.Middleware.Logger - log requests (method, url, status, and time) Tesla.Middleware.KeepRequest - keep request body and headers Tesla.Middleware.PathParams - use templated URLs Formats Tesla.Middleware.FormUrlencoded - urlencode POST body, useful for POSTing a map/keyword list Tesla.Middleware.JSON - JSON request/response body Tesla.Middleware.Compression - gzip and deflate Tesla.Middleware.DecodeRels - decode Link header into opts[:rels] field in response Auth Tesla.Middleware.BasicAuth - HTTP Basic Auth Tesla.Middleware.BearerAuth - HTTP Bearer Auth Tesla.Middleware.DigestAuth - Digest access authentication Error handling Tesla.Middleware.Timeout - timeout request after X milliseconds despite of server response Tesla.Middleware.Retry - retry few times in case of connection refused Tesla.Middleware.Fuse - fuse circuit breaker integration","ref":"readme.html#middleware","title":"Tesla - Middleware","type":"extras"},{"doc":"All HTTP functions, such as Tesla.get/3 and Tesla.post/4 , can take a dynamic client as the first argument. This allows to use convenient syntax for modifying the behaviour in runtime. Consider the following case: GitHub API can be accessed using OAuth token authorization. We can't use plug Tesla.Middleware.Headers, [{&quot;authorization&quot;, &quot;token here&quot;}] since this would be compiled only once and there is no way to insert dynamic user token. Instead, we can use Tesla.client to create a client with dynamic middleware: defmodule GitHub do # notice there is no `use Tesla` def user_repos ( client , login ) do # pass `client` argument to `Tesla.get` function Tesla . get ( client , &quot;/user/&quot; &lt;&gt; login &lt;&gt; &quot;/repos&quot; ) end def issues ( client ) do Tesla . get ( client , &quot;/issues&quot; ) end # build dynamic client based on runtime arguments def client ( token ) do middleware = [ { Tesla.Middleware.BaseUrl , &quot;https://api.github.com&quot; } , Tesla.Middleware.JSON , { Tesla.Middleware.Headers , [ { &quot;authorization&quot; , &quot;token: &quot; &lt;&gt; token } ] } ] Tesla . client ( middleware ) end end and then: client = GitHub . client ( user_token ) client |&gt; GitHub . user_repos ( &quot;teamon&quot; ) client |&gt; GitHub . get ( &quot;/me&quot; )","ref":"readme.html#runtime-middleware","title":"Tesla - Runtime middleware","type":"extras"},{"doc":"Tesla supports multiple HTTP adapter that do the actual HTTP request processing. Tesla.Adapter.Httpc - the default, built-in erlang httpc adapter Tesla.Adapter.Hackney - hackney , &quot;simple HTTP client in Erlang&quot; Tesla.Adapter.Ibrowse - ibrowse , &quot;Erlang HTTP client&quot; Tesla.Adapter.Gun - gun , &quot;HTTP/1.1, HTTP/2 and Websocket client for Erlang/OTP&quot; Tesla.Adapter.Mint - mint , &quot;Functional HTTP client for Elixir with support for HTTP/1 and HTTP/2&quot; Tesla.Adapter.Finch - finch , &quot;An HTTP client with a focus on performance, built on top of Mint and NimblePool .&quot; When using adapter other than :httpc remember to add it to the dependencies list in mix.exs defp deps do [ { :tesla , &quot;~&gt; 1.4.0&quot; } , { :hackney , &quot;~&gt; 1.10&quot; } # when using hackney adapter ] end Adapter options In case there is a need to pass specific adapter options you can do it in one of four ways: Supplying them as a keyword list in a tuple via config: config :tesla , adapter : { Tesla.Adapter.Hackney , [ recv_timeout : 30_000 ] } Using adapter macro: defmodule GitHub do use Tesla adapter Tesla.Adapter.Hackney , recv_timeout : 30_000 , ssl_options : [ certfile : &quot;certs/client.crt&quot; ] end Using Tesla.client/2 : def new ( ... ) do middleware = [ ... ] adapter = { Tesla.Adapter.Hackney , [ recv_timeout : 30_000 ] } Tesla . client ( middleware , adapter ) end Passing directly to request functions such as MyClient.get/3 or Tesla.get/3 . MyClient . get ( &quot;/&quot; , opts : [ adapter : [ recv_timeout : 30_000 ] ] ) Tesla . get ( client , &quot;/&quot; , opts : [ adapter : [ recv_timeout : 30_000 ] ] )","ref":"readme.html#adapters","title":"Tesla - Adapters","type":"extras"},{"doc":"If adapter supports it, you can pass a Stream as body, e.g.: defmodule ElasticSearch do use Tesla plug Tesla.Middleware.BaseUrl , &quot;http://localhost:9200&quot; plug Tesla.Middleware.JSON def index ( records_stream ) do stream = records_stream |&gt; Stream . map ( fn record -&gt; %{ index : [ some , data ] } end ) post ( &quot;/_bulk&quot; , stream ) end end Each piece of stream will be encoded as JSON and sent as a new line (conforming to JSON stream format).","ref":"readme.html#streaming","title":"Tesla - Streaming","type":"extras"},{"doc":"You can pass a Tesla.Multipart struct as the body: alias Tesla.Multipart mp = Multipart . new ( ) |&gt; Multipart . add_content_type_param ( &quot;charset=utf-8&quot; ) |&gt; Multipart . add_field ( &quot;field1&quot; , &quot;foo&quot; ) |&gt; Multipart . add_field ( &quot;field2&quot; , &quot;bar&quot; , headers : [ { &quot;content-id&quot; , &quot;1&quot; } , { &quot;content-type&quot; , &quot;text/plain&quot; } ] ) |&gt; Multipart . add_file ( &quot;test/tesla/multipart_test_file.sh&quot; ) |&gt; Multipart . add_file ( &quot;test/tesla/multipart_test_file.sh&quot; , name : &quot;foobar&quot; ) |&gt; Multipart . add_file_content ( &quot;sample file content&quot; , &quot;sample.txt&quot; ) { :ok , response } = MyApiClient . post ( &quot;https://httpbin.org/post&quot; , mp )","ref":"readme.html#multipart","title":"Tesla - Multipart","type":"extras"},{"doc":"You can set the adapter to Tesla.Mock in tests: # config/test.exs # Use mock adapter for all clients config :tesla , adapter : Tesla.Mock # or only for one config :tesla , MyApi , adapter : Tesla.Mock Then, mock requests before using your client: defmodule MyAppTest do use ExUnit.Case import Tesla.Mock setup do mock ( fn %{ method : :get , url : &quot;https://example.com/hello&quot; } -&gt; % Tesla.Env { status : 200 , body : &quot;hello&quot; } %{ method : :post , url : &quot;https://example.com/world&quot; } -&gt; json ( %{ &quot;my&quot; =&gt; &quot;data&quot; } ) end ) :ok end test &quot;list things&quot; do assert { :ok , % Tesla.Env { } = env } = MyApi . get ( &quot;https://example.com/hello&quot; ) assert env . status == 200 assert env . body == &quot;hello&quot; end end","ref":"readme.html#testing","title":"Tesla - Testing","type":"extras"},{"doc":"A Tesla middleware is a module with Tesla.Middleware.call/3 function, that at some point calls Tesla.run/2 with env and next to process the rest of stack. defmodule MyMiddleware do @behaviour Tesla.Middleware def call ( env , next , options ) do env |&gt; do_something_with_request ( ) |&gt; Tesla . run ( next ) |&gt; do_something_with_response ( ) end end The arguments are: env - Tesla.Env instance next - middleware continuation stack; to be executed with Tesla.run/2 with env and next options - arguments passed during middleware configuration ( plug MyMiddleware, options ) There is no distinction between request and response middleware, it's all about executing Tesla.run/2 function at the correct time. For example, a request logger middleware could be implemented like this: defmodule Tesla.Middleware.RequestLogger do @behaviour Tesla.Middleware def call ( env , next , _ ) do env |&gt; IO . inspect ( ) |&gt; Tesla . run ( next ) end end and response logger middleware like this: defmodule Tesla.Middleware.ResponseLogger do @behaviour Tesla.Middleware def call ( env , next , _ ) do env |&gt; Tesla . run ( next ) |&gt; IO . inspect ( ) end end See built-in middlewares for more examples. Middleware should have documentation following this template: defmodule Tesla.Middleware.SomeMiddleware do @moduledoc &quot;&quot;&quot; Short description what it does Longer description, including e.g. additional dependencies. ### Examples ``` defmodule MyClient do use Tesla plug Tesla.Middleware.SomeMiddleware, most: :common, options: &quot;here&quot; end ``` ### Options - `:list` - all possible options - `:with` - their default values &quot;&quot;&quot; @behaviour Tesla.Middleware end","ref":"readme.html#writing-middleware","title":"Tesla - Writing middleware","type":"extras"},{"doc":"You can also use Tesla directly, without creating a client module. This however won’t include any middleware. # Example get request { :ok , response } = Tesla . get ( &quot;https://httpbin.org/ip&quot; ) response . status # =&gt; 200 response . body # =&gt; &quot;{\\n &quot;origin&quot;: &quot;87.205.72.203&quot;\\n}\\n&quot; response . headers # =&gt; [{&quot;content-type&quot;, &quot;application/json&quot; ...}] { :ok , response } = Tesla . get ( &quot;https://httpbin.org/get&quot; , query : [ a : 1 , b : &quot;foo&quot; ] ) # Example post request { :ok , response } = Tesla . post ( &quot;https://httpbin.org/post&quot; , &quot;data&quot; , headers : [ { &quot;content-type&quot; , &quot;application/json&quot; } ] )","ref":"readme.html#direct-usage","title":"Tesla - Direct usage","type":"extras"},{"doc":"Making requests 101 # GET /path get ( &quot;/path&quot; ) # GET /path?a=hi&amp;b[]=1&amp;b[]=2&amp;b[]=3 get ( &quot;/path&quot; , query : [ a : &quot;hi&quot; , b : [ 1 , 2 , 3 ] ] ) # GET with dynamic client get ( client , &quot;/path&quot; ) get ( client , &quot;/path&quot; , query : [ page : 3 ] ) # arguments are the same for GET, HEAD, OPTIONS &amp; TRACE head ( &quot;/path&quot; ) options ( &quot;/path&quot; ) trace ( &quot;/path&quot; ) # POST, PUT, PATCH post ( &quot;/path&quot; , &quot;some-body-i-used-to-know&quot; ) put ( &quot;/path&quot; , &quot;some-body-i-used-to-know&quot; , query : [ a : &quot;0&quot; ] ) patch ( &quot;/path&quot; , multipart ) Configuring HTTP functions visibility # generate only get and post function use Tesla , only : ~w(get post)a # generate only delete function use Tesla , only : [ :delete ] # generate all functions except delete and options use Tesla , except : [ :delete , :options ] Disable docs for HTTP functions use Tesla , docs : false Encode only JSON request (do not decode response) plug Tesla.Middleware.EncodeJson Decode only JSON response (do not encode request) plug Tesla.Middleware.DecodeJson Use other JSON library # use JSX plug Tesla.Middleware.JSON , engine : JSX , engine_opts : [ strict : [ :comments ] ] # use custom functions plug Tesla.Middleware.JSON , decode : &amp; JSX . decode / 1 , encode : &amp; JSX . encode / 1 Custom middleware defmodule Tesla.Middleware.MyCustomMiddleware do def call ( env , next , options ) do env |&gt; do_something_with_request ( ) |&gt; Tesla . run ( next ) |&gt; do_something_with_response ( ) end end","ref":"readme.html#cheatsheet","title":"Tesla - Cheatsheet","type":"extras"},{"doc":"Documentation for 0.x branch","ref":"readme.html#0-x-to-1-0-migration-guide","title":"Tesla - 0.x to 1.0 Migration Guide","type":"extras"},{"doc":"Fork it ( https://github.com/teamon/tesla/fork ) Create your feature branch ( git checkout -b my-new-feature ) Commit your changes ( git commit -am 'Add some feature' ) Push to the branch ( git push origin my-new-feature ) Create new Pull Request","ref":"readme.html#contributing","title":"Tesla - Contributing","type":"extras"},{"doc":"This project is licensed under the MIT License - see the LICENSE file for details Copyright (c) 2015-2021 Tymon Tobolski","ref":"readme.html#license","title":"Tesla - License","type":"extras"},{"doc":"This project is sponsored by ubots - Useful bots for Slack","ref":"readme.html#sponsors","title":"Tesla - Sponsors","type":"extras"},{"doc":"The MIT License (MIT) Copyright (c) 2015-2021 Tymon Tobolski Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]